Subject: bug#76559: 31.0.50; [-O3 + PGTK] Crash when 'copying as kill'/'killing word'

From: Iurie Marian <[email-masked]>
Date: Thu, 27 Feb 2025 19:50:25 +0100

@Po Lu: I have just tested, your proposal and of course it works well (I've
used that build version for a while).

Btw, I noticed that this crash occurs ONLY for builds where -O3 and LTO are
used together.

On Thu, 27 Feb 2025 at 14:30, Po Lu <[email-masked]> wrote:

> Eli Zaretskii <[email-masked]> writes:
>
> >> Date: Thu, 27 Feb 2025 12:22:36 +0000
> >> From: Pip Cet <[email-masked]>
> >> Cc: Po Lu <[email-masked]>, [email-masked],
> >> [email-masked], [email-masked], [email-masked],
> >> Stefan Kangas <[email-masked]>, Paul Eggert
> >> <[email-masked]>
> >>
> >> "Eli Zaretskii" <[email-masked]> writes:
> >>
> >> > I believe we should recommend against using -O3.  Too many bad bugs
> >>
> >> If we do that, can we include link time optimization in that?  I find
> >> LTO'd code extremely difficult to read, since things like the calling
> >> convention no longer apply (even when a function call isn't inlined, LTO
> >> can still conclude that some registers survive the call and reuse them
> >> even though the calling convention disagrees).
>
> It's marginally easier to read the RTL (which ultimately becomes no more
> than a Lisp-like representation of the assembly but with some tree
> expressions and analogous details preserved for reference,
> e.g. non-inlined procedure calls).
>
> > Maybe we should also recommend against LTO.  Paul, WDYT about this?
>
> I think there is no occasion to compile Emacs with any optimization
> options besides -O2.
>